<?php
namespace PME\Controllers\Requisicao;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class CalcPrevConsController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $birtStrategy;
    protected $environment;
    protected $lista;
    protected $utilities;
    protected $newCode;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $environment, $lista, $utilities, $newCode, $connection) {
        $this->entityManager = $entityManager;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
        $this->lista = $lista;
        $this->utilities = $utilities;
        $this->newCode = $newCode;
        $this->connection = $connection;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'PME00800' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "PRODINI"        => "P_PRODINI",
            "PRODFIN"        => "P_PRODFIN",
            "CDPRODINI"      => "P_CDPRODINI",
            "CDPRODFIN"      => "P_CDPRODFIN",
            "NMPRODINI"      => "P_NMPRODINI",
            "NMPRODFIN"      => "P_NMPRODFIN",
            "CDTIPOCUSTO"    => "P_TIPOCUSTO",
            "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
            "ORDENA"         => "P_ORDENA",
            "IMPFILTRO"      => "P_IMPFILTRO",
            "IMPSERV"        => "P_IMPSERV",
            "ARREDONDAMENTO" => "P_STARREDONDA",
            "ACRESCIMO"      => "P_ACRECIMO",
            "TAMACNIVEL"     => "P_TAMACNIVEL",
            "TAMCODIGO"      => "P_TAMCODIGO",
            "NRORG"          => "P_NRORG",
            "IDSUBGRUP"      => "P_IDSUBGRUP",
            "CDFILCENTPME"   => "P_CDFILCENTPME",
            "NMFILCENTPME"   => "P_NMFILCENTPME",
            "DTDE"           => "P_DTPERIINI",
            "DTATE"          => "P_DTPERIFIN",
            "CDGRUPPROD"     => "P_CDGRUPPROD",
            "CDFILCENTCMP"   => "P_CDFILCENTCMP",
            "LISTASERVICO"   => "L_CDSERVFILI",
            "LISTATIPOCARD"  => "L_CDTIPOCARD",
            "LISTASUBGRPROD" => "L_CDSUBGRPROD",
            "PRODUCTMASK"    => "P_PRODUCTMASK",
            "TSERVICOS"      => "P_TSERVICOS",
            "TUNIDADES"      => "P_TUNIDADES",
            "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00801' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_TIPOCUSTO",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00802' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_TIPOCUSTO",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00803' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"     => "P_PRODINI",
              "PRODFIN"     => "P_PRODFIN",
              "CDPRODINI"   => "P_CDPRODINI",
              "CDPRODFIN"   => "P_CDPRODFIN",
              "NMPRODINI"   => "P_NMPRODINI",
              "NMPRODFIN"   => "P_NMPRODFIN",
              "CDTIPOCUSTO" => "P_TIPOCUSTO",
              "NMTIPOCUSTO" => "P_NMTIPOCUSTO",
              "ORDENA"      => "P_ORDENA",
              "IMPFILTRO"   => "P_IMPFILTRO",
              "IMPSERV"     => "P_IMPSERV",
              "ARREDONDAMENTO"  => "P_STARREDONDA",
              "ACRESCIMO"   => "P_ACRECIMO",
              "TAMACNIVEL"       => "P_TAMACNIVEL",
              "TAMCODIGO"   => "P_TAMCODIGO",
              "NRORG"       => "P_NRORG",
              "IDSUBGRUP"   => "P_IDSUBGRUP",
              "CDFILCENTPME"=> "P_CDFILCENTPME",
              "NMFILCENTPME"=> "P_NMFILCENTPME",
              "DTDE"        => "P_DTPERIINI",
              "DTATE"       => "P_DTPERIFIN",
              "CDGRUPPROD" => "P_CDGRUPPROD",
              "CDFILCENTCMP"=> "P_CDFILCENTCMP",
              "LISTASERVICO"  => "L_CDSERVFILI",
              "LISTATIPOCARD" => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK" => "P_PRODUCTMASK",
              "TSERVICOS" => "P_TSERVICOS",
              "TUNIDADES"   => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        if($row['CALCULAR']) $this->calculatePrevCons($request, $response);
        
        $nrorg = $this->environment->getNrOrg();

        $servicos = join('_', $this->getServicos($row));

        if(empty($row['TIPOCARD'])){
          $tipoCard = join('_', $this->getTipoCard($row));
        }else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
        
        $subGrupProd = '';
        if(!empty($row['SUBGRUPPROD'])){
          foreach($row['SUBGRUPPROD'] as $element){
            $subGrupProd .= $element['CDSUBGRPROD'].'_';
          }
          $row['CDGRUPPROD'] = $row['SUBGRUPPROD'][0]['CDGRUPPROD'];
        }else{
          $row['SUBGRUPPROD'] = null;
          $row['CDGRUPPROD'] = null;
        }

        $row['LISTASERVICO'] = $this->lista->geraLista($servicos, $nrorg);
        
        $row['LISTATIPOCARD'] = $this->lista->geraLista($tipoCard, $nrorg);
        
        if(!empty($subGrupProd)){
          $row['IDSUBGRUP'] = 'S';
          $row['LISTASUBGRPROD'] = $this->lista->geraLista($subGrupProd, $nrorg);
        }else{
          $row['LISTASUBGRPROD'] = null;
          $row['IDSUBGRUP'] = 'N';
        }
        
        if($row['SERVICO'] == null) $row['TSERVICOS'] = 'T';
        else if(count($row['SERVICO']) == 1) {
           $cdservico = $row['SERVICO'][0];
           $cdcentral = $row['CDFILCENTPME'];
           $descricaoServico = $this->returnDescricaoServico($cdservico, $tipoCard, $cdcentral)[0]['DESCRICAO'];
           $row['TSERVICOS'] = $descricaoServico;
        }
        else $row['TSERVICOS'] = 'V';

        if($row['UNIDADE'] == null) $row['TUNIDADES'] = 'T';
        else if(count($row['UNIDADE']) == 1) {
           $cdfilial = $row['UNIDADE'][0];
           $descricaoFilial = $this->returnDescricaoFilial($cdfilial)[0]['DESCRICAO'];
           $row['TUNIDADES'] = $descricaoFilial;
        }
        else $row['TUNIDADES'] = 'V';

        if($row['ORDENA'] == 0) $row['TAMCODIGO'] = 10;
        else $row['TAMCODIGO'] = 0;
        
        $row['NRORG'] = $nrorg;
        $row['CDFILCENTCMP'] = null;

        $this->formatProd($row);

        $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
        $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
    
    private function formatProd($row){
      if(empty($row['PRODINICIAL']['CDARVPROD'])){
        $row['CDPRODINI'] = '0';
        $row['NMPRODINI'] = 'Todos';
        $row['PRODINI'] = '';
      }else {
        $row['CDPRODINI'] = $row['PRODINICIAL']['CDARVPROD'];
        $row['NMPRODINI'] = $row['PRODINICIAL']['NMPRODUTO'];
        // $row['PRODINI'] = $row['PRODINICIAL']['CDARVPROD'];
      } 
      

      if(empty($row['PRODFINAL']['CDARVPROD'])){
        $row['CDPRODFIN'] = 'zzzzzzzzzzz';
        $row['NMPRODFIN'] = 'Todos';
        $row['PRODFIN'] = '';
      }else{
        $row['CDPRODFIN'] = str_pad($row['PRODFINAL']['CDARVPROD'], 10, 'z');
        $row['NMPRODFIN'] = $row['PRODFINAL']['NMPRODUTO'];
        // $row['PRODFIN'] = $row['PRODFINAL']['CDARVPROD'];
      }
    }
    
    public function returnDescricaoServico($cdservico, $tipocard, $cdcentral) {
        $sql = "SELECT DISTINCT
                      ST.CDSERVFILI,
                      S.NMSERVICO,
                      ST.CDSERVFILI
                      || ' - '
                      || S.NMSERVICO AS DESCRICAO,
                      S.NRORG
                  FROM
                      SERVTIPOCARD   ST
                      INNER JOIN SERVICO        S ON S.NRORG = ST.NRORG
                                              AND S.CDFILIAL = ST.CDFILCENTPME
                                              AND S.CDSERVFILI = ST.CDSERVFILI
                                              AND S.IDTIPOSERV = 'M'
                  WHERE
                      ST.NRORG = :NRORG
                      AND ST.CDFILCENTPME = :CDFILCENTPME
                      AND ( INSTR(:CDTIPOCARD, ST.CDTIPOCARD) > 0 )
                      AND S.CDSERVFILI = :CDSERVFILI
                  ORDER BY
                      ST.CDSERVFILI";
        $params = array(
            'NRORG' => $this->environment->getNrOrg(),
            'CDFILCENTPME' => $cdcentral,
            'CDTIPOCARD' => $tipocard,
            'CDSERVFILI' => $cdservico
        );

        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
   }
    
    public function returnDescricaoFilial($cdfilial) {
        $sql = "SELECT F.CDFILIAL || ' ' || F.NMFILIAL AS DESCRICAO, F.NRORG FROM FILIAL F WHERE F.CDFILIAL = :CDFILIAL AND F.NRORG = :NRORG";
        $params = array(
            'CDFILIAL' => $cdfilial,
            'NRORG' => $this->environment->getNrOrg()
        );

        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
   }

    public function calculatePrevCons(DTO\Request\Row $request, DTO\Response $response) {
      try{
        $row = $request->getRow();
        $nrconsplan = $this->procedurePrevCons($row);
        // $response->setMetadata(['nrconsplan' => $nrconsplan]);
        $this->insertIntoLogprevconspme($row, $nrconsplan);
      }catch(\Exception $e) {
        $response->setError(new DTO\Response\Error($e->getMessage(), 1));
      }
    }

    private function procedurePrevCons($row){
      $nrorg = $this->environment->getNrOrg();
      $cdoperador = $this->environment->getCdOperador();
      $nrconsplan = $this->newCode->getCodeByTableName('CONSPLAN'.$row['CDFILCENTPME'], $nrorg);

      if(empty($row['UNIDADE'])){
        $cdfilial = join('_', $this->getUnidades($row));
      }else $cdfilial = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];

      if(empty($row['SERVICO'])){
        $cdservfili = join('_', $this->utilities->getDistinctServicos($row['CDFILCENTPME'], $row['UNIDADE']));
      } else $cdservfili = is_array($row['SERVICO']) ? join("_", $row['SERVICO']) : $row['SERVICO'];
      
      if(empty($row['TIPOCARD'])){
        $tipoCard = join('_', $this->getTipoCard($row));
      }else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
      
      $cdprodIni = $row['PRODINICIAL']['CDARVPROD'] ? $row['PRODINICIAL']['CDARVPROD'] : 0;
      $cdprodFin = $row['PRODFINAL']['CDARVPROD'] ? $row['PRODFINAL']['CDARVPROD'] : 'zzzzzzzzzz';

      $connection = $this->entityManager->getConnection();
      $procedureCons = new StoredProcedure($connection, 'PREVISAO_CONSUMO_PME');
  
      $procedureCons->addParam(new Param('P_CDFILCENTPME', Param::PARAM_INPUT, $row['CDFILCENTPME'],   Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDTIPOCARD',   Param::PARAM_INPUT, $tipoCard,              Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $cdfilial,              Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDSERVFILI',   Param::PARAM_INPUT, $cdservfili,            Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT, $row['DTDE'],           Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT, $row['DTATE'],          Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT, $row['ACRESCIMO'],      Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT, $cdprodIni,             Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT, $cdprodFin,             Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $cdoperador,            Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_DTHRCALCPC',   Param::PARAM_INPUT, date("d/m/Y"),          Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_INPUT, $nrconsplan,            Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT, $row['ARREDONDAMENTO'], Param::PARAM_TYPE_STR));
      $procedureCons->execute();

      return $nrconsplan;
    }
   
    private function getServicos($row){
      if(empty($row['UNIDADE'])) $unidade = 'T';
      else $unidade = join("_", $row['UNIDADE']);
      $rows = $this->utilities->getServicos($row['CDFILCENTPME'], $unidade);
      $servicos = [];
      $filteredRows = [];
      if(empty($row['SERVICO'])) $filteredRows = $rows;
      else {
        if(!is_array($row['SERVICO'])) $row['SERVICO'] = [$row['SERVICO']];
        foreach($row['SERVICO'] as $a){
          foreach($rows as $b){
            if($a == $b['CDSERVFILI']) array_push($filteredRows, $b);
          } 
        } 
      }
      foreach($filteredRows as $serv){
        array_push($servicos, $serv['CDFILIAL'].$serv['CDSERVFILI']);
      }
      return $servicos;
    }

    private function getUnidades($row){
      $rows = $this->utilities->getUnidades($row['CDFILCENTPME']);
      $unidades = [];
      foreach($rows as $unid){
        array_push($unidades, $unid['CDFILIAL']);
      }
      return $unidades;
    }

    private function getTipoCard($row){
      $rows = $this->utilities->getTipoCard($row['CDFILCENTPME']);
      $tiposCard = [];
      foreach($rows as $tipo){
        array_push($tiposCard, $tipo['CDTIPOCARD']);
      }
      return $tiposCard;
    }
    
    private function insertIntoLogprevconspme($row, $nrconsplan) {
      try {
          
          if(empty($row['UNIDADE'])){
            $cdfilial = 'T';
          } else $cdfilial = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
          
          if(empty($row['SERVICO'])){
            $cdservfili = 'T';
          } else $cdservfili = is_array($row['SERVICO']) ? join("_", $row['SERVICO']) : $row['SERVICO'];
          
          if(empty($row['TIPOCARD'])){
            $tipoCard = 'T';
          } else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
          
          $nrorg = $this->environment->getNrOrg();
          $cdoperador = $this->environment->getCdOperador();
          
          $this->connection->beginTransaction();
          
          $query = "INSERT INTO LOGPREVCONSPME(CDFILCENTPME, CDTIPOCARD, CDSERVFILI, CDFILIAL, CDOPERADOR, DTHRCALCPR, DTINICIALPC , DTFINALPC , CDPRODINICPC , CDPRODFINAPC , PEACRESCIMPR, NRCONSPLANPC )
                          SELECT T.CDFILCENTPME, T.CDTIPOCARD, S.CDSERVFILI, F.CDFILIAL, :P_CDOPERADOR, :P_DTHRCALCPR, :P_DTINICIALPC, :P_DTFINALPC, :P_CDPRODINICPC ,
                              :P_CDPRODFINAPC ,  :P_PEACRESCIMPR,  :P_NRCONSPLANPC 
                            FROM TIPOCARD T
                           INNER JOIN SERVTIPOCARD S ON T.CDFILCENTPME = S.CDFILCENTPME 
                              AND T.CDTIPOCARD = S.CDTIPOCARD
                              AND T.NRORG = S.NRORG
                              AND ( INSTR(:P_CDSERVFILI, S.CDSERVFILI) > 0 OR :P_CDSERVFILI = 'T' )
                           INNER JOIN FILITIPOCARD F ON F.CDFILCENTPME = T.CDFILCENTPME 
                              AND F.CDTIPOCARD = T.CDTIPOCARD 
                              AND F.IDTCARATFILI = 'S'
                              AND F.NRORG = T.NRORG
                              AND ( INSTR(:P_CDFILIAL, F.CDFILIAL) > 0 OR :P_CDFILIAL = 'T' ) 
                           WHERE T.CDFILCENTPME = :P_CDFILCENTPME
                             AND T.IDTPCARDATIV = 'S'
                             AND T.NRORG = :P_NRORG
                             AND ( INSTR(:P_CDTIPOCARD, T.CDTIPOCARD) > 0 OR :P_CDTIPOCARD = 'T' )";
            
          $params = array(
            'P_DTFINALPC' => $row['DTATE'], 
            'P_CDFILIAL' => $cdfilial,
            'P_CDOPERADOR' => $cdoperador,
            'P_CDPRODFINAPC' => $row['PRODFINAL']["CDPRODUTO"],
            'P_CDPRODINICPC' => $row['PRODINICIAL']["CDPRODUTO"],
            'P_NRCONSPLANPC' => $nrconsplan,
            'P_PEACRESCIMPR' => $row['ACRESCIMO'],
            'P_CDSERVFILI' =>   $cdservfili,
            'P_CDFILCENTPME' => $row['CDFILCENTPME'],
            'P_DTHRCALCPR' => date("d/m/Y H:i:s"),
            'P_DTINICIALPC' => $row['DTDE'],
            'P_NRORG' => $nrorg,
            'P_CDTIPOCARD' => $tipoCard,
          );
            
	        $this->connection->prepare($query)->execute($params);
	        $this->connection->commit();
	    } catch (\Exception $e) {
	    	$this->connection->rollback();
		  }
    }
}