<?php
namespace Planejamento\Repositories;

class Prevreti extends \Doctrine\ORM\EntityRepository
{
    public function get_maxNrPrPrevReti($nrorg, $campos){
        $sql = "SELECT LPAD(NVL(MAX(PR.NRPRPREVRETI), 0)+1, 4, '0') AS NRPRPREVRETI
                  FROM PREVRETI PR
                 WHERE (PR.CDFILIAL   = :P_CDFILIAL)
                   AND (PR.NRORG      = :P_NRORG)
                   AND (PR.CDSERVFILI = :P_CDSERVFILI)
                   AND (PR.DTPREVRETI = :P_DTPREVRETI)
                   AND (PR.IDPREVRETI = :P_IDPREVRETI)
                   AND (PR.NRREQUEXTR = '0000000000')";

        $params = array(
            "P_CDFILIAL"    => $campos['CDFILIAL'],
            "P_NRORG"       => $nrorg,
            "P_CDSERVFILI"  => $campos['CDSERVFILI'],
            "P_DTPREVRETI"  => $campos['DTPREVRETI'],
            "P_IDPREVRETI"  => $campos['IDPREVRETI']
        );


        $result = $this->_em->getConnection()->fetchColumn($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public function get_produtoId($nrorg, $campos, $id){
        $sql = "SELECT PD.CDARVPROD
                  FROM PREVRETI PR, PRODUTO  PD
                 WHERE (PR.CDFILIAL = :P_CDFILIAL)
                   AND (PR.NRORG    = :P_NRORG)
                   AND (PR.CDSERVFILI = :P_CDSERVFILI)
                   AND (PR.DTPREVRETI = :P_DTPREVRETI)
                   AND (PR.NRREQUEXTR = '0000000000')
                   AND (PD.CDPRODUTO = PR.CDPRODUTO)
                   AND (PD.CDARVPROD = :P_CDARVPROD)";

        $params = array(
            "P_CDFILIAL"    => $campos['CDFILIAL'],
            "P_NRORG"       => $nrorg,
            "P_CDSERVFILI"  => $campos['CDSERVFILI'],
            "P_DTPREVRETI"  => $campos['DTPREVRETI'],
            "P_CDARVPROD"   => $id
        );


        $result = $this->_em->getConnection()->fetchColumn($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public static function verificaRequisicaoCalculada($nrorg, $filial, $requisicao, $servico, $dtRetirada, $tamNivel){
        if ($requisicao === '0000000000') {
            $sql = "SELECT PREVRETI.CDFILIAL, PREVRETI.CDSERVFILI, PREVRETI.DTPREVRETI, PREVRETI.CDPRODUTO,
                           PRODUTO.CDARVPROD, SUM(PREVRETI.QTPREVRETI) AS QTPREVRETI,
                           RPAD(SUBSTR(PRODUTO.CDARVPROD, 1, :P_TAMNIVEL), 10, ' ') AS CDNIVEPROD,
                           PRODUTO.NMPRODUTO, PRODUTO.SGUNIDADE, PRODUTO.CDPRODESTO, SERVICO.NMSERVICO,
                           PREVRETI.CDTIPOPRAT, PREVRETI.CDPRATO, PREVRETI.CDFILAUXPRAT
                      FROM PRODUTO, PREVRETI, SERVICO
                     WHERE SERVICO.NRORG = :P_NRORG
                       AND SERVICO.CDFILIAL = :P_CDFILIAL
                       AND SERVICO.CDSERVFILI = :P_CDSERVFILI
                       AND PREVRETI.NRORG = SERVICO.NRORG
                       AND PREVRETI.CDFILIAL = SERVICO.CDFILIAL
                       AND PREVRETI.CDSERVFILI = SERVICO.CDSERVFILI
                       AND PREVRETI.IDPREVTPPRAT = SERVICO.IDUTRETIPRAT
                       AND PREVRETI.DTPREVRETI = :P_DTPREVRETI
                       AND PREVRETI.NRREQUEXTR = '0000000000'
                       AND PRODUTO.NRORG = PREVRETI.NRORG
                       AND PRODUTO.CDPRODUTO = PREVRETI.CDPRODUTO
                      GROUP BY PREVRETI.CDFILIAL, PREVRETI.CDSERVFILI, PREVRETI.DTPREVRETI, PREVRETI.CDPRODUTO,
                               PRODUTO.CDARVPROD, 7, PRODUTO.NMPRODUTO, PRODUTO.SGUNIDADE, PRODUTO.CDPRODESTO,
                               SERVICO.NMSERVICO, PREVRETI.CDTIPOPRAT, PREVRETI.CDPRATO, PREVRETI.CDFILAUXPRAT
                      ORDER BY PREVRETI.CDTIPOPRAT, PREVRETI.CDPRATO, 7, PRODUTO.NMPRODUTO";

            $param = array(
                'P_NRORG' => $nrorg,
                'P_CDFILIAL' => $filial,
                'P_CDSERVFILI' => $servico,
                'P_DTPREVRETI' => $dtRetirada,
                'P_TAMNIVEL' => $tamNivel,
            );
        } else {
            $sql = "SELECT PREVRETI.CDFILIAL, PREVRETI.CDSERVFILI, PREVRETI.DTPREVRETI, PREVRETI.CDPRODUTO,
                           PRODUTO.CDARVPROD, SUM(PREVRETI.QTPREVRETI) AS QTPREVRETI,
                           RPAD(SUBSTR(PRODUTO.CDARVPROD, 1, :P_TAMNIVEL), 10, ' ') AS CDNIVEPROD,
                           PRODUTO.NMPRODUTO, PRODUTO.SGUNIDADE, PRODUTO.CDPRODESTO, SERVICO.NMSERVICO, PREVRETI.CDTIPOPRAT,
                           PREVRETI.CDPRATO, PREVRETI.CDFILAUXPRAT
                      FROM PRODUTO, SERVICO, PREVRETI
                     WHERE PREVRETI.NRORG = :P_NRORG
                       AND PREVRETI.CDFILIAL = :P_CDFILIAL
                       AND PREVRETI.CDSERVFILI = :P_CDSERVFILI
                       AND PREVRETI.NRREQUEXTR = :P_NRREQUEXTR
                       AND SERVICO.NRORG = PREVRETI.NRORG
                       AND SERVICO.CDFILIAL = PREVRETI.CDFILIAL
                       AND SERVICO.CDSERVFILI = PREVRETI.CDSERVFILI
                       AND SERVICO.IDUTRETIPRAT = PREVRETI.IDPREVTPPRAT
                       AND PRODUTO.NRORG = SERVICO.NRORG
                       AND PRODUTO.CDPRODUTO = PREVRETI.CDPRODUTO
                     GROUP BY PREVRETI.CDFILIAL, PREVRETI.CDSERVFILI, PREVRETI.DTPREVRETI, PREVRETI.CDPRODUTO,
                              PRODUTO.CDARVPROD, 7, PRODUTO.NMPRODUTO, PRODUTO.SGUNIDADE, PRODUTO.CDPRODESTO,
                              SERVICO.NMSERVICO, PREVRETI.CDTIPOPRAT, PREVRETI.CDPRATO, PREVRETI.CDFILAUXPRAT
                     ORDER BY PREVRETI.CDTIPOPRAT, PREVRETI.CDPRATO, 7, PRODUTO.NMPRODUTO";

            $param = array(
                'P_NRORG' => $nrorg,
                'P_CDFILIAL' => $filial,
                'P_NRREQUEXTR' => $requisicao,
                'P_CDSERVFILI' => $servico,
                'P_TAMNIVEL' => $tamNivel,
            );
        }

        $entityManager = \Setforms2\Shared\Registry::getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $param);
        return count($result)>0 ? $result : array();
    }


}