import {
  IEventParam,
  Loader,
  Metadata,
  IDictionary,
} from '@zeedhi/core';

import {
  GridEditable, Select, Form,
} from '@zeedhi/common';
  
export class Ger21000FormasApresentacaoController {
  public gridEditController = Loader.getInstance('GridEditableController');

  public crudController = Loader.getInstance('CrudController');

  public utilities = Loader.getInstance('Utilities');

  public fillCode({ component }: IEventParam<Select>) {
    if (component.value < 0) component.value = '0';
    component.value = component.value.padStart(3, '0');
  }

  public formatCode() {
    const form = Metadata.getInstance<Form>('formGrid');
    const grid: GridEditable = Metadata.getInstance('grid');
    const editedRows = grid.getEditedRows() as IDictionary;
    
    if (form.validate() && editedRows.length > 0) {
      editedRows.forEach((row: IDictionary) => {
        row.CDAPRERECE = row.CDAPRERECE.padStart(3, '0');
      });
      // grid.datasource.loading = true;
      this.crudController.saveRows(editedRows, 'formaapresentacao', grid).then(() => {
        this.utilities.showAlert('alert', 'pme::salvoComSucesso', 'success');
      }).catch((error: string) => {
        this.utilities.showAlert('alert', `pme::${error}`, 'error');
      }).finally(() => {
        this.gridEditController.defaultState(grid);
      });
    }
  }
}
