import {
  Loader,
  Metadata,
  IDictionary,
} from '@zeedhi/core';

import {
  GridEditable, Select, Button, Form,
} from '@zeedhi/common';
  
export class Ger80500NutricionistaController {
  public gridEditableController = Loader.getInstance('GridEditableController');
  
  public crudController = Loader.getInstance('CrudController');
  
  public newRow = false;
  
  private utilities = Loader.getInstance('Utilities');
  
  public addRow({ component }: IDictionary) {
    const form = Metadata.getInstance<Form>('formFilter');
    const unidade = Metadata.getInstance<Select>('CDFILIAL');

    if (form.validate()) {
      if (!this.newRow) {
        if (unidade.value !== null) {
          this.gridEditableController.addRow({ component });
        }
      } else unidade.validations.required.message = 'pme::campoObrigatorio';
    }
  }
  
  public reloadTelaNutricionista() {
    const formFiltro: Form = Metadata.getInstance<Form>('formFilter');
    if (formFiltro.validate()) {
      const gridNutricionista = Metadata.getInstance<GridEditable>('gridNutricionista');
      gridNutricionista.datasource.get();
    }
  }
  
  public save() {
  // public save({ component }: IEventParam<Button>) {
    const form = Metadata.getInstance<Form>('formNutricionista');
    const grid: GridEditable = Metadata.getInstance('gridNutricionista');
    const editedRows = grid.getEditedRows();
    if (form.validate() && editedRows.length > 0) {
      const unidade = Metadata.getInstance<Select>('CDFILIAL');
      
      editedRows.forEach((row: IDictionary) => {
        if (row.__is_new) {
          row.CDNUTRICIO = row.CDOPERADOR;
          row.CDFILIAL = unidade.value;
        }
      });
      this.crudController.saveRows(editedRows, 'nutricio').then(() => {
        this.utilities.showAlert('Alert', 'pme::salvoComSucesso', 'success');
        this.gridEditableController.defaultState(grid);
        // this.gridEditableController.reload({ component });
      }).catch(() => {
        this.utilities.showAlert('Alert', 'pme::impossivelAdicionar', 'error');
      });
    }
  }

  public setFilterUnidade() {
    const addButton = Metadata.getInstance<Button>('addButton');
    const grid: GridEditable = Metadata.getInstance('gridNutricionista');
    const unidade = Metadata.getInstance<Select>('CDFILIAL');
    const filter = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: unidade.value,
      },
    ];

    addButton.disabled = true;
    grid.datasource.filter = filter;
    grid.datasource.get().then(() => {
      if (unidade.value !== null) addButton.disabled = false;
    });
  }

  public setFilterOperador() {
    const unidade = Metadata.getInstance<Select>('CDFILIAL');
    
    return [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: unidade.value,
      },
    ];
  }
}
